#include "WorkerAccess.h"

#include "Logger.h"
#include "ProcessRename.h"
#include "ProcessConfig.h"


#include "DataQueue.hpp"
#include "DataAccess.h"
#include "ThreadTargetSelect.h"
#include "ThreadExtractControl.h"
#include "ThreadDbUpdate.h"


#include <stdlib.h>
#include <signal.h>
#include <pthread.h>
#include <errno.h>
#include <string.h>
#include <time.h>



// 프로세스 종료 전 처리할 종료 관련 각 작업을 일괄로 처리하기 위한 함수.
void ReadyToExitWorkerAccess()
{
	// Logger 객체 종료 처리.
	CLogger::Exit();

	return;
}


// Worker Access 프로세스에 대한 대한 종료 처리 수신시.
static void SignalWorkerAccessTerminate( int nSignalNumber )
{
	// Signal Number 에 따른 로깅처리.
	if( nSignalNumber == SIGTERM )
	{
		_LOG( LINF, "[Access:%d] Process exit by SIGTERM signal. Good Bye..", getpid() );
	}
	else
	{
		_LOG( LWAR, "[Access:%d] Process exit by abnormal signal[%d], Good Bye..", getpid(), nSignalNumber );
	}

	ReadyToExitWorkerAccess();

	// 종료전 잠시 대기
	struct timespec sleep;
	sleep.tv_sec = 0;
	sleep.tv_nsec = 500000000;  // 0.5 sec
	nanosleep( &sleep, NULL );

	exit( EXIT_SUCCESS );
}

// Worker::Access Process 의 signal 처리기...
void SetWorkerAccessSignalHandler()
{
	sigset_t set;
	struct sigaction act;

	memset( &act, 0x00, sizeof( act ) );
	sigfillset( &set );
	sigprocmask( SIG_SETMASK, &set, NULL );
	sigfillset( &act.sa_mask );

	// 무시 처리 signal
	act.sa_handler = SIG_IGN;
	sigaction( SIGPIPE, &act, NULL );	/* desciptor 오류 발생시 Process가 죽는 것은 방지하기 위하여 설정 */
	sigaction( SIGHUP, &act, NULL );	/* process를 기동시킨 관리자의 로그아웃시, 또는 config reload 등의 처리 signal*/
	sigaction( SIGINT, &act, NULL );	/* ^C 키를 누른 경우 받는 신호 => demon 으로 기동되기 땜시 이 신호 못받음 */
	sigaction( SIGQUIT, &act, NULL );	/* 키보드에 의한  Abort 신호 처리 => ? */

	// Worker 프로세스는 자식 프로세스가 존재하지 않으므로 그냥 무시처리함.
	act.sa_handler = SIG_IGN;
	sigaction( SIGCHLD, &act, NULL );

	/* 각종 에러나 사용자의 종료 신호 처리 */
	act.sa_handler = SignalWorkerAccessTerminate;
	sigaction( SIGTERM, &act, NULL );	/* kill -TERM 에 의한 프로세스 종료시 */

	// 나머지 신호는 default 처리.

	sigemptyset( &set );                  /* 신호 처리기 처리 설정 위한 블록 해제 */
	sigprocmask( SIG_SETMASK, &set, NULL );

	return;
}


// Worker::Access 프로세스의 Main 역활을 수행하기 위한 함수.
int WorkerAccessMain( void )
{
	// Process Rename..
	set_ps_display( PROG_NAME": Access init", false );

	// Set Signal Handler
	SetWorkerAccessSignalHandler();


	// 1. 사용할 객체 초기화 처리


	// DB 에서 조회된 access time 추출 대상 content 목록 정보를 저장할 queue 객체
	CDataQueue<CDataAccess> queueTarget;
	queueTarget.SetMaxSize( CProcessConfig::GetInstance()->GetMaxQueueSize() );

	// access time 정보가 추출된 content 목록 정보를 저장할 queue 객체
	CDataQueue<CDataAccess> queueComplete;
	queueComplete.SetMaxSize( CProcessConfig::GetInstance()->GetMaxQueueSize() );

	// access time 추출 대상 조회를 수행하는 thread 생성
	CThreadTargetSelect threadTargetSelect( &queueTarget, CProcessConfig::GetInstance()->GetAccessTimeExtractService() );

	// access time 추출 thread 를 control 하는 thread 객체 생성
	CThreadExtractControl threadExtractControl( &queueTarget, &queueComplete, CProcessConfig::GetInstance()->GetMaxThreadCount() );

	// 추출된 access time 정보를 DB 에 update 처리를 수행하는 thread 객체 생성
	CThreadDbUpdate threadDbUpdate( &queueComplete, CProcessConfig::GetInstance()->GetAccessTimeExtractService() );



	// 2. 각 모듈 기동 처리

	set_ps_display( PROG_NAME": Access start", false );


	// DB udpate 모듈 start
	if( threadDbUpdate.Start() == false )
	{
		_LOG( LWAR, "[Access:%d] db update thread start failed. -> Process exit.", getpid() );

		ReadyToExitWorkerAccess();

		// EXIT_FAILURE 를 반환하여 재생성 처리 방지...
		return EXIT_FAILURE;
	}


	// access time 추출을 담당하는 thrad 객체 start
	if( threadExtractControl.Start() == false )
	{
		_LOG( LWAR, "[Access:%d] content access time extract control thread start failed. -> Process exit.", getpid() );

		ReadyToExitWorkerAccess();

		// EXIT_FAILURE 를 반환하여 재생성 처리 방지...
		return EXIT_FAILURE;
	}

	// access time 추출 대한 content 조회 thread start
	if( threadTargetSelect.Start() == false )
	{
		_LOG( LWAR, "[Access:%d] content select thread start failed. -> Process exit.", getpid() );

		ReadyToExitWorkerAccess();

		// EXIT_FAILURE 를 반환하여 재생성 처리 방지...
		return EXIT_FAILURE;
	}



	// 대기
	while( 1 )
	{
		// 할일 없어서.. 시그널 수신까지 대기 한다.
		pause();
	}


	// 종료시 정리 작업 수행
	// - 실제로는 동작하지 않는 code 
	ReadyToExitWorkerAccess();
	return EXIT_SUCCESS;

}

